C
C CG CG DOUBLE PRECISION FUNCTION GIVING LFG  LN(ACTIVITY) OF CARBON IN AUSTENITE
      DOUBLE PRECISION FUNCTION MAP_STEEL_CG(X,T,W,R)
      IMPLICIT NONE
      DOUBLE PRECISION AJ,DG,EG,T,R,W,X
      AJ=1.0-DEXP(-W/(R*T))
         IF(X .LE. 1.0D-10) THEN
           MAP_STEEL_CG=DLOG(1.0D-10)
         ELSE
           DG=DSQRT(1.0-2.0*(1.0+2.0*AJ)*X+(1.0+8.0*AJ)*X*X)
           EG=5.0*DLOG((1.0-2.0*X)/X)+6.0*W/(R*T)+
     &     (38575.0-13.48*T)/(R*T)
           MAP_STEEL_CG=EG+6.0D+00*DLOG((DG-1+3*X)/(DG+1-3*X))
         ENDIF
      RETURN
      END
